//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%37F0D2A50C90.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%37F0D2A50C90.cm

//## begin module%37F0D2A50C90.cp preserve=no
//## end module%37F0D2A50C90.cp

//## Module: MulComponent%37F0D2A50C90; Package body
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/MulComponent.cxx

//## begin module%37F0D2A50C90.additionalIncludes preserve=no
//## end module%37F0D2A50C90.additionalIncludes

//## begin module%37F0D2A50C90.includes preserve=yes
//## end module%37F0D2A50C90.includes

// SumComponent
#include <XSModel/Model/Component/SumComponent.h>
// CGroupBase
#include <XSModel/Model/Component/CGroupBase.h>
// ComponentBase
#include <XSModel/Model/Component/ComponentBase.h>
// typeinfo
#include <typeinfo>
// MulComponent
#include <XSModel/Model/Component/MulComponent.h>


//## begin module%37F0D2A50C90.declarations preserve=no
//## end module%37F0D2A50C90.declarations

//## begin module%37F0D2A50C90.additionalDeclarations preserve=yes
#include <XSUtil/FunctionUtils/XSModelFunction.h>
#include <XSModel/Model/UniqueEnergy.h>
#include "XSstreams.h"
//## end module%37F0D2A50C90.additionalDeclarations


// Class MulComponent 

MulComponent::MulComponent(const MulComponent &right)
  //## begin MulComponent::MulComponent%3628095A0096_copy.hasinit preserve=yes
      : Component(right)
  //## end MulComponent::MulComponent%3628095A0096_copy.hasinit
  //## begin MulComponent::MulComponent%3628095A0096_copy.initialization preserve=yes
  //## end MulComponent::MulComponent%3628095A0096_copy.initialization
{
  //## begin MulComponent::MulComponent%3628095A0096_copy.body preserve=yes
  cloneParameters(*this,right);
  //## end MulComponent::MulComponent%3628095A0096_copy.body
}

MulComponent::MulComponent (CGroupBase* p)
  //## begin MulComponent::MulComponent%37EF94C1DE70.hasinit preserve=yes
         : Component(p)
  //## end MulComponent::MulComponent%37EF94C1DE70.hasinit
  //## begin MulComponent::MulComponent%37EF94C1DE70.initialization preserve=yes
  //## end MulComponent::MulComponent%37EF94C1DE70.initialization
{
  //## begin MulComponent::MulComponent%37EF94C1DE70.body preserve=yes
  //## end MulComponent::MulComponent%37EF94C1DE70.body
}


MulComponent::~MulComponent()
{
  //## begin MulComponent::~MulComponent%3628095A0096_dest.body preserve=yes
  componentBase()->deleteParameters();
  //## end MulComponent::~MulComponent%3628095A0096_dest.body
}



//## Other Operations (implementation)
SumComponent& MulComponent::operator * (SumComponent& right) const
{
  //## begin MulComponent::operator*%37682B6B6A08.body preserve=yes
  std::set<UniqueEnergy*>::const_iterator rp = getUniqueEnergies().begin();
  std::set<UniqueEnergy*>::const_iterator rpEnd = getUniqueEnergies().end();
  
  while (rp != rpEnd)
  {
     const UniqueEnergy* uniqueEng = *rp;
     const RealArray& model = uniquePhotonArray(uniqueEng);
     if (model.size())
     {      
        RealArray& flux = right.uniquePhotonArray(uniqueEng);
        flux *= model;

        if ( right.isError() || isError())
        {
           RealArray& fluxError = right.uniquePhotonErrArray(uniqueEng);
           const RealArray& mulFactor = model;

           if ( right.isError())
           {
              fluxError *= (mulFactor * mulFactor);          
           }
           if (isError())
           {
              if ( !right.isError())
              {
                 fluxError.resize(flux.size(),0.);
                 right.isError(true);       
              }
              fluxError += flux*flux*uniquePhotonErrArray(uniqueEng);         
           }

        }
     }
     ++rp;
  }
  
   return right;
  //## end MulComponent::operator*%37682B6B6A08.body
}

MulComponent* MulComponent::clone (CGroupBase* p) const
{
  //## begin MulComponent::clone%38E3B5E39D08.body preserve=yes
  MulComponent* cloned = new MulComponent(*this);
  cloned->setParent(p);
  return cloned;    
  //## end MulComponent::clone%38E3B5E39D08.body
}

void MulComponent::copy (const Component& right)
{
  //## begin MulComponent::copy%3A953F240283.body preserve=yes
  if ( typeid(*this) != typeid(right) ) 
          throw RedAlert("*** Programmer Error: copying to wrong type ***");  
  MulComponent __temp(static_cast<const MulComponent&>(right));
  swap(__temp);   
  //## end MulComponent::copy%3A953F240283.body
}

void MulComponent::calculate (bool saveComponentFlux, bool frozen)
{
  //## begin MulComponent::calculate%3ADB04070040.body preserve=yes
  if (saveComponentFlux) saveUniquePhotonArray(saveComponentFlux);
  
  
  const std::set<UniqueEnergy*>& energies = getUniqueEnergies();
  std::set<UniqueEnergy*>::const_iterator en   = energies.begin();
  std::set<UniqueEnergy*>::const_iterator enEnd = energies.end();
  
  const std::vector<Parameter *>&  parameterSet = componentBase()->parameterSet();
  size_t  numParams(parameterSet.size());
  RealArray  startValues(numParams);
  for (size_t  i=0; i<numParams; i++)
  {
     startValues[i] = parameterSet[i]->value();
  }
  
  while (en != enEnd)
  {
     const UniqueEnergy* uniqueEng = *en;      
     size_t spectrumNumber = *uniqueEng->clientSpectra().begin();
     RealArray& fluxArray = uniquePhotonArray(uniqueEng);
     RealArray& fluxErrArray = uniquePhotonErrArray(uniqueEng);

     const XSModelFunction*  generator(componentBase()->generator());
     (*generator) (uniqueEng->energy(), startValues, spectrumNumber,
              fluxArray, fluxErrArray,componentBase()->initString());


     // fluxErrArray is initialized to zero in generator
     // and then resized to zero if it wasn't used.
     fluxErrArray.size() > 0  ? error(true) : error(false);

     debugPrint(tcout,"\nModel Output MulComponent::calculate() ");

     ++en;
  }

  //## end MulComponent::calculate%3ADB04070040.body
}

// Additional Declarations
  //## begin MulComponent%3628095A0096.declarations preserve=yes
  //## end MulComponent%3628095A0096.declarations

//## begin module%37F0D2A50C90.epilog preserve=yes
//## end module%37F0D2A50C90.epilog
